''''
Source : http://sciences-physiques.ac-besancon.fr/2019/05/12/aspects-energetiques-des-phenomenes-mecaniques-avec-python/

Effectuer le bilan énergétique d’un système en mouvement

Ce programme permet de représenter l’évolution des différentes formes d’énergie du système en mouvement au cours du temps
'''
import matplotlib.pyplot as plt

#Les fonctions------------------------------------------------------

def graphique(Ec, Epp, Em, t):
    plt.title("Evolution des formes d'énergies du système")
    plt.xlabel('t en (s)')
    plt.ylabel('Energies en (J)')
    plt.xlim(0,1.2*max(t))
    plt.ylim=(0,1.2*max(Em))
    plt.plot(t,Ec,'r.',label='Ec')
    plt.plot(t,Epp,'b.',label='Epp')
    plt.plot(t,Em,'g.',label='Em')
    plt.legend()

def calcul_vitesses(abscisses,ordonnees,temps):
    v=[]
    for n in range(len(abscisses)-1):
        v_x=(abscisses[n+1]-abscisses[n])/(temps[n+1]-temps[n])
        v_y=(ordonnees[n+1]-ordonnees[n])/(temps[n+1]-temps[n])
        v.append((v_x**2+v_y**2)**0.5)
    temps=temps[:-1]   # -1 : la dernière valeur de la liste temps[] est exclue
    return v,temps

#Le programme principal--------------------------------------------
x=[...,...,...]
z=[...,...,...]
t=[...,...,...]
masse=...
g=...

v, temps_v = calcul_vitesses(x,z,t)

#-----------------------------------
Ec=[0.5*masse*vitesse**2 for vitesse in v]
#-----------------------------------
Epp=[]
for i in range(len(v)):
    Epp.append(masse*g*z[i])
#-----------------------------------
Em=[]
for i in range(len(v)):
    Em.append(Ec[i]+Epp[i])
#-----------------------------------

graphique(Ec, Epp, Em, temps_v)
plt.show()