''''
Source : http://sciences-physiques.ac-besancon.fr/2019/05/12/suivi-et-modelisation-de-levolution-dun-systeme-chimique-avec-python/

Modélisation de l’évolution des quantités de matières des réactifs et des produits 
d’un système chimique siège d’une transformation chimique totale

La transformation chimique s’écrit : aA + bB  → cC + dD

Dans le programme principal, l’utilisateur saisi :
  - les nombres stœchiométriques a, b, c et d de l’équation,
  - les quantités initiales n_Ai, n_Bi, n_Ci, et n_Di de réactifs et de produits,
  - Les noms des espèces chimiques A, B, C et  D.
  
Les quantités des deux réactifs sont affichées en bleu celles des deux produits 
en rouge sur le graphique.
'''

import matplotlib.pyplot as plt

#Les fonctions------------------------------------------------------
def courbes(a,b,c,d,n_Ai,n_Bi,n_Ci,n_Di,A,B,C,D):
    x=0
    n_A, n_B, n_C, n_D = n_Ai, n_Bi, n_Ci, n_Di
    dx=(min(n_A,n_B)/100)
    plt.ion()
    x_max=min(n_Ai/a,n_Bi/b)
    plt.xlim(0,1.2*x_max)
    plt.ylim(0,1.2*max(n_A,n_B))
    plt.xlabel('Avancement x (mol)')
    plt.ylabel('n (en mol)')
    plt.grid()
    plt.plot(x,n_A,'b.',label=A)
    plt.plot(x,n_B,'b+',label=B)
    plt.plot(x,n_C,'r.',label=C)
    plt.plot(x,n_D,'r+',label=D)
    plt.legend()
    while (n_A>0) and (n_B>0):
        plt.plot(x,n_A,'b.')
        plt.plot(x,n_B,'b+')
        plt.plot(x,n_C,'r.')
        plt.plot(x,n_D,'r+')
        plt.pause(0.01)
        x=x+dx
        n_A=n_Ai-a*x
        n_B=n_Bi-b*x
        n_C=n_Ci+c*x
        n_D=n_Di+d*x
                     
#Le programme principal---------------------------------------------
'''Partie du programme à compléter : 
   -  coefficients stoechiométriques des réactifs et des produits
   -  quantités de matières initiales
   -  écriture des composés
'''
#Equation du type aA + bB -> cC +  dD
a, b, c, d = ..., ..., ..., ...
n_Ai, n_Bi, n_Ci, n_Di= ..., ..., ..., ...
A, B, C, D = "???", "???", "???", "???"
courbes(a,b,c,d,n_Ai,n_Bi,n_Ci,n_Di,A,B,C,D)
plt.ioff()
plt.show()



