''''
Source : http://sciences-physiques.ac-besancon.fr/2019/05/16/les-ondes-mecaniques-avec-python-en-classe-de-premiere/

Représenter un signal périodique et illustrer l’influence de son amplitude sur sa représentation

Ce programme permet de de tracer un réseau de courbes représentant le même signal mais dont l’amplitude varie.
'''

import matplotlib.pyplot as plt
import numpy as np

#Les fonctions-----------------------------------------
def tracer(t,S,couleur,text):
    plt.title("S = f(t)")
    plt.xlabel("Temps en s")
    plt.ylabel("Amplitude du signal S")
    plt.grid()
    plt.plot(t, S, color=couleur, label=text)
    plt.legend()
    
#Le programme principal--------------------------------
A=[1,2,3,4,5]
C=[(0.2,0,0),(0.4,0,0),(0.6,0,0),(0.8,0,0),(1,0,0)] #Les couleurs sont codées en système RVB,
                                                    #la proportion de chacune des couleurs est
                                                    #désignée par une valeur comprise entre 0 et 1
T=5
t=np.linspace(0,10,100) #Création d'un tableau Numpy contenant 100 valeurs de t variant de 0 à 10
for i in range(len(A)):
    S = A[i]*np.sin((2*np.pi/T)*t)
    legende="A="+str(A[i])
    tracer(t,S,C[i],legende)
plt.show()