''''
Source : http://sciences-physiques.ac-besancon.fr/2019/05/16/les-ondes-mecaniques-avec-python-en-classe-de-premiere/

Représenter un signal périodique et illustrer l’influence de sa période sur sa représentation

Dans ce programme proposé, des représentations du signal se succèdent avec une période de plus en plus grande. 
On obtient un effet d’animation qui montre l’influence de la période T sur la représentation du signal.
'''

import matplotlib.pyplot as plt
import numpy as np

#Les fonctions-----------------------------------------
def tracer(t,S,text):
    plt.clf() #Efface la figure courante
    plt.title("S = f(t)")
    plt.xlabel("Temps en s")
    plt.ylabel("Amplitude du signal S")
    plt.grid()
    plt.plot(t, S, color='red', label=text)
    plt.legend(loc='upper right')
    plt.pause(0.2) #Les courbes sont tracées toutes les 0,2 s ce qui donne l’effet d’animation
    
#Le programme principal--------------------------------
A=3
T=np.linspace(1,5,40)
t=np.linspace(0,10,500)
for i in range(len(T)):
    S = A*np.sin((2*np.pi/T[i])*t)
    legende="T={0:1.1f}s".format(T[i])
    tracer(t,S,legende)
plt.show()