''''
Source : http://sciences-physiques.ac-besancon.fr/2019/05/16/les-ondes-mecaniques-avec-python-en-classe-de-premiere/

Simuler la propagation d'une onde périodique

Pour simuler le déplacement d’une onde, il est possible de commencer par fixer l’amplitude A de l’onde, 
sa période T ainsi que sa célérité v. On fait ensuite le choix de calculer 5 fois la valeur de la longueur d’onde 
et de stocker cette valeur dans la variable x_max qui servira à afficher 5 longueurs d’onde du signal dans la fenêtre graphique.

Pour travailler sur les notions de périodicité spatiale et temporelle, un point d’abscisse fixe
et ajouté. 
'''
import matplotlib.pyplot as plt
import numpy as np

#Les fonctions-----------------------------------------
def tracer(x, y, amplitude, x_max, x_point, y_point):
    plt.clf()
    plt.title("Représentation de l'onde")
    plt.xlabel("Déplacement (en m)")
    plt.xlim(0,x_max)
    plt.ylabel("Amplitude")
    plt.ylim(-2*amplitude,2*amplitude)
    plt.grid()
    plt.plot(x, y, color='red')
    plt.plot(x_point,y_point,'bo')
    plt.pause(0.1)
    
#Le programme principal--------------------------------
A=3
T=2
v=5
long = v*T
x_max=5*long
xP=20
t=np.linspace(0,10,100) #Création d'un tableau Numpy de 100 valeurs de t comprises entre 0 et 10s
x=np.linspace(0,x_max,100*x_max)
for i in range(len(t)):
    y = A*np.sin((2*np.pi/T)*(t[i]-x/v))
    yP = A*np.sin((2*np.pi/T)*(t[i]-xP/v))
    tracer(x,y,A,x_max,xP,yP)
plt.show()
