import numpy as np
import matplotlib.pyplot as plt

# U et I sont à compléter
# Tableau entre crochets, nombres séparés d'une virgule
U = np.array([-5.0,-4.0,-3.0,-1.0,0,1.0,2.0,3.0,4.0,5.0])
I = np.array([-0.052,-0.039,-0.028,-0.011,0,0.01,0.021,0.032,0.039,0.05])

#Tracé de la courbe
plt.grid()
plt.title('Caractéristique tension-intensité')
plt.xlabel('I(en A)')
plt.ylabel('U(en V)')
plt.plot(I,U,'+',label= 'Points issus de la mesure')
plt.legend()

# Effectuer une regression linéaire et la tracer
Umod = np.polyfit(I,U,1)
print('Um =', round(Umod[0],2),'x','I','+',round(Umod[1],4))

Reg = np.poly1d(Umod)
x = np.linspace(1.2*min(I), 1.2*max(I))
y = Reg(x)
plt.plot(x, Reg(x))

plt.show()

#Remarque : la deuxième étape est mise en standby (en commentaire), à l'aide du triple quote '''