﻿# PRECISION DE LA VERRERIE POUR LA MESURE D'UN VOLUME


from scipy import *   # Importer la bibliothèque scipy, module qui concerne le calcul scientifique
from pylab import *   # Importer la bibliothèque pylab, qui permet d’utiliser de manière aisée les bibliothèques NumPy
                      # (calcul scientifique) et matplotlib (représentation graphique à 2D)

## A COMPLETER PAR LES ELEVES

# Compléter la liste suivante en indiquant la masse du volume d'eau prélevé à l'aide du bécher
# ATTENTION : la masse doit être exprimée en g
m_becher=array([46.8,47.7,43.1,43.6,44.8,45.5, 43.7,38.4,46.8,46.3]) # Crée un tableau à 1 dimension (et l'affecte à la variable m_becher)

# Compléter la liste suivante en indiquant la masse du volume d'eau prélevé à l'aide de l'eprouvette graduée
# ATTENTION : la masse doit être exprimée en g
m_eprouvette=array([49.4,49.8,49.6,49.7,47.7,47.3,48.8,49.2,47.9])

# Compléter la liste suivante en indiquant la masse du volume d'eau prélevé à l'aide de la fiole jaugée
# ATTENTION : la masse doit être exprimée en g
m_fiole=array([48.8,49.1,49.0,49.3,47.7,48,49.4,49.5,48.9,49])


## CALCUL DE LA MOYENNE DE LA MASSE OBTENUE + ECART TYPE

n=len(m_becher) # Compte le nombre d'éléments présents dans le tableau à 1 dimension et l'affecte à la variable n
print('Nombre de mesures :', n)

# Moyenne de la masse obtenue + écart type à partir des mesures effectuées avec un bécher
print('Moyenne de m_becher :',m_becher.mean(),' g') # Affiche la moyenne sur l'ensemble des mesures effectuées
s=std(m_becher, ddof = 1) # Calcul l'écart-type à n-1 (ou déviation standard au sens statistique) et l'affecte à la variable s
print('Ecart-type non biaisé pour la série de mesures de m_becher :', s, 'g') # Affiche l'écart-type non biaisé

# Moyenne de la masse obtenue + écart type à partir des mesures effectuées avec une éprouvette graduée
print('Moyenne de m_eprouvette :',m_eprouvette.mean(),' g')
t=std(m_eprouvette, ddof = 1)
print('Ecart-type non biaisé pour la série de mesures de m_eprouvette :', t, 'g')

# Moyenne de la masse obtenue + écart type à partir des mesures effectuées avec une fiole jaugée
print('Moyenne de m_fiole :',m_fiole.mean(),' g')
u=std(m_fiole, ddof = 1)
print('Ecart-type non biaisé pour la série de mesures de m_fiole :', u, 'g')

## TRACE DES HISTOGRAMMES

m_th=50.0 # masse théorique de 50,0 mL d'eau

figure("Masse du volume d'eau prélevé") # Définit le nom de la figure
subplot(3,1,1) # Partage la figure en 3x1 emplacements de graphes (3 lignes et 1 colonne) et sélectionne le 1er emplacement
# pour les instructions graphiques suivantes. Les numéros des graphes sont comptés par ligne.

# histogramme de couleur bleue pour les mesures faites avec le bécher
hist([m_becher],range=(m_th-10,m_th+10),bins=int(2*((m_th+10)-(m_th-10))),color=['b'])  # la fonction bins est associé
#aux nombre d'intervalles pour l'axe des abscisses
ylabel('Nb de mesures') # Définit le nom des ordonnées
legend(["avec le bécher (en g)"]) # Définit la légende
subplot(3,1,2)

# histogramme de couleur rouge pour les mesures faites avec l'éprouvette graduée
hist([m_eprouvette],range=(m_th-10,m_th+10),bins=int(2*((m_th+10)-(m_th-10))),color=['r'])
ylabel('Nb de mesures')
legend(["avec l'eprouvette graduée (en g)"])
subplot(3,1,3)

# histogramme de couleur verte pour les mesures faites avec l'éprouvette graduée
hist([m_fiole],range=(m_th-10,m_th+10),bins=int(2*((m_th+10)-(m_th-10))),color=['g'])
ylabel('Nb de mesures')
legend(["avec la fiole jaugée (en g)"])

show() # Affiche toutes les fenêtres définies précedemment dans le code


