import matplotlib.pyplot as plt

#Les fonctions------------------------------------------------------
def Tracer_des_positions(abscisses,ordonnees):
    plt.scatter(abscisses,ordonnees,marker='+')
    plt.title('Positions successives occupées par le système')
    plt.xlabel('x en (m)')
    plt.ylabel('Altitude z en (m)')
    plt.xlim(0.8*min(abscisses),1.2*max(abscisses))

def calcul_vitesses(abscisses,ordonnees,temps):
    v_x=[]
    v_y=[]
    for n in range(len(abscisses)-1):
        print(n)
        v_x.append((abscisses[n+1]-abscisses[n])/(temps[n+1]-temps[n]))
        v_y.append((ordonnees[n+1]-ordonnees[n])/(temps[n+1]-temps[n]))
    temps=temps[:-1]
    return v_x,v_y,temps

def representation_vecteur_vitesse(abscisses,ordonnees,v_x,v_y):
    for i in range(len(v_x)):
        plt.quiver(abscisses[i], ordonnees[i] ,v_x[i] , v_y[i], scale_units='xy',angles='xy', scale=15)
    Tracer_des_positions(abscisses,ordonnees)

#Le programme principal--------------------------------------------
x=[0.00,0.50,1.00,1.50,2.00,2.50,3.00,3.50,4.00,4.50,5.00]
z=[5.00,4.95,4.80,4.56,4.22,3.77,3.23,2.60,1.86,1.03,0.09]
t=[0.00,0.10,0.20,0.30,0.40,0.50,0.60,0.70,0.80,0.90,1.00]
v_x,v_y,temps_v=calcul_vitesses(x,z,t)
representation_vecteur_vitesse(x,z,v_x,v_y)
plt.show()