﻿import numpy as np
import matplotlib.pyplot as plt
from pylab import*

import csv #Importation du module

source = open('pointage.csv','r') #On ouvre le fichier "pointage.csv" contenu dans le même dossier que le fichier python, en lecture 'read'. Le tout est enregistré dans une variable nommé "source".
lecteur = csv.reader(source,delimiter=";") #On créer un lecteur de csv. On précise le délimiteur utilisé.
x,y = [],[] #On créer 2 listes vides pour accueillir les données

for row in lecteur: #On parcourt le lecteur
    print(row) #affiche la ligne
    x.append(float(row[0])) #stocke la 1ère valeur dans la liste x
    y.append(float(row[1])) #stocke la 2nde valeur dans la liste y

#Tracé de la chronophotographie
plt.plot(x,y,'o',markersize=4)
xlim(-2, 2)
plt.xlabel("x (en m)")
plt.ylabel("y (en m)")
plt.title("Chronophotographie et vecteurs vitesse")

#Tracé des vecteurs vitesses
N=len(x)
dt=0.040
for k in range (0,N-1) :
    Vy=(y[k+1]-y[k])/dt

    echelle = 0.02
    Vy=echelle*Vy


    plt.quiver(x[k],y[k],0,Vy,
    color="red", scale=0.6,scale_units='xy')

source.close() # On ferme le fichier

#Affichage
plt.show()

