'''
Trace du diagramme de distribution d'un couple acide faible/base faible

Les lignes 22 et 25 sont a renseigner en fonction du couple
'''

# Import des bibliotheques
import matplotlib.pyplot as plt
import numpy as np

def diagramme(pKa):
    pH = np.arange(0,15,0.1)
    X = 10**(pH-pKa) # X = Cb/Ca =Pb/Pa
    Pb = X*100/(1+X) # % de base faible
    Pa = 100-Pb # % d'acide faible
    plt.figure (figsize = (10,8))
    plt.plot(pH,Pa,"r+-",label="acide")
    plt.plot(pH,Pb,"b+-",label="base")
    plt.xlabel("pH")
    plt.ylabel("%")
    plt.legend()
    plt.grid()
    plt.title ("Diagramme de distribution du couple acide ethanoique/ion ethanoate")
    plt.show

pKa = 4.8
diagramme (pKa)