# -*- coding: utf-8 -*-
"""
Created on Mon Jan 18 15:20:48 2021
@author: ddhdx
Tracé de l'histogramme des valeurs mesurées de capacité d'un condensateur
Calcul et affichage de la valeur moyenne et de l'incertitude-type
"""
#Importation des bibliothèques------------------------------------------------
import numpy as np
import matplotlib.pyplot as plt
from math import sqrt

#Importation des données------------------------------------------------------
data = np.loadtxt("donnees.txt", skiprows=1)

C = data[:,1] #On met dans C toutes les lignes (:) de la 2eme colonne
C_mean = C.mean() #On utilise la méthode .mean() de la bibliothèque numpy
sigma_C = C.std() #On utilise la méthode .std() de la bibliothèque numpy
Delta_C = sigma_C / sqrt(len(C))

print('Résultat de la mesure de C :', round(C_mean,4),'uF')
print('Incertitude-type sur la mesure de C :', round(Delta_C,4),'uF')

#Histogramme-------------------------------------------------------------------
legende = ["N = ",str(len(C))]
plt.hist(C, bins = 30, range = (C.min(),C.max()), edgecolor = 'blue', label = "".join(legende))
plt.xlabel("C en uF")
plt.ylabel("Nb de mesure")
plt.legend()
plt.show()