'''
Programme Python permettant de tester la troisieme loi de Kepler
GRAC Terminale Spe PC, academie de la Guyane, le 20/04/2020
'''

import numpy as np
import matplotlib.pyplot as plt
import scipy.stats as sc

#Affichage des donnees utiles pour tester le programme

print("Vous trouverez ci-dessous les rayons et les periodes des orbites de Venus, la Terre, Mars et de Jupiter")
print("Venus : rayon orbite = 108 millions de km ; periode de revolution = 225 j ")
print("Terre : rayon orbite = 150 millions de km ; periode de revolution = 365 j ")
print("Mars : rayon orbite = 228 millions de km ; periode de revolution = 687 j ")
print("Jupiter : rayon orbite = 778 millions de km ; periode de revolution = 4333 j ")

#Saisie des rayons ou des demi-grand axes des orbites ainsi que des periodes des planetes
a1 = float(input("Entrer le demi-grand axe de la 1ere planete en millions de km "))
print ("Le rayon est",a1,"millions de km.")
T1 = float(input("Entrer la periode de la 1ere planete en annees "))
print ("La periode est",T1,"annees.")

a2 = float(input("Entrer le demi-grand axe de la 2eme planete en millions de km "))
print ("Le rayon est",a2,"millions de km.")
T2 = float(input("Entrer la periode de la 2eme planete en annees "))
print ("La periode est",T2,"annees.")

a3 = float(input("Entrer le demi-grand axe de la 3eme planete en millions de km "))
print ("Le rayon est",a3,"millions de km.")
T3 = float(input("Entrer la periode de la 3eme planete en annees "))
print ("La periode est",T3,"annees.")

a4 = float(input("Entrer le demi-grand axe de la 4eme planete en millions de km "))
print ("Le rayon est",a4,"millions de km.")
T4 = float(input("Entrer la periode de la 4eme planete en annees "))
print ("La periode est",T4,"annees.")

#Creation des listes pour calcul et affichage
a = np.array([a1, a2, a3, a4])
T = np.array([T1, T2, T3, T4])
G = 6.67e-11
#Calcul des constantes a^3 et T^2
acube = (a*1e9)**3
Tcarre = (T*24*3600)**2

#Affichage des points de mesure et regression lineraire
plt.plot(acube, Tcarre, "+", color = "red")
plt.grid()
droite = sc.linregress(acube, Tcarre)
coeff = droite.slope
print("Coeff directeur : ","%0.3e" % coeff)
oorigine=droite.intercept
print("Ordonnee e l'origine : ","%0.3e" % oorigine)

#Etiquettes des axes
plt.xlabel('$a^3 (m^3)$')
plt.ylabel('$T^2 (s^2)$')

#Calcul de la masse du corps attracteur
M = (4*(np.pi)**2)/(G*coeff)

#Affichage de la droite modelisee
print ("La masse du Soleil est ","%0.3e" % M, "kg")
Tcarremodelise = coeff*acube+oorigine
plt.plot(acube, Tcarremodelise, color = "blue")
plt.title('$T^2 = f(a^3)$')
plt.show()

